import java.awt.image.MemoryImageSource;

public class FadeTransition extends BannerTransition {
   static final int TOTAL_FRAMES = 8;
   static final int MULTIPLIER = 6102575;
   int[][] random;
   int pixelsPerFrame;

   public FadeTransition() {
      super.numOfFrames = 7;
   }

   public void finishInit() {
      this.pixelsPerFrame = super.pixelsPerImage / 8;
      this.random = new int[8][this.pixelsPerFrame];
      int[] var1 = new int[8];

      for(int var2 = 0; var2 < 8; ++var2) {
         var1[var2] = 0;
      }

      int var4 = this.pixelsPerFrame * 8;
      int var5 = (int)System.currentTimeMillis();

      int var6;
      for(var6 = 10; (this.pixelsPerFrame % var6 > 0 || super.imageHeight % var6 == 0) && var6 > 1; --var6) {
      }

      int var7 = this.pixelsPerFrame / var6;
      int var8 = var4 / var6;

      int var3;
      for(int var9 = 0; var9 < var7; this.random[var3][var1[var3]++] = var9++) {
         var5 *= 6102575;
         var3 = var5 >>> 29;
      }

      var5 += 20560;

      try {
         Thread.sleep(150L);
      } catch (InterruptedException var17) {
      }

      for(int var10 = var7; var10 < var8; this.random[var3][var1[var3]++] = var10++) {
         var5 *= 6102575;
         var3 = var5 >>> 29;

         while(var1[var3] >= var7) {
            ++var3;
            if (var3 >= 8) {
               var3 = 0;
            }
         }
      }

      for(int var11 = 0; var11 < super.numOfFrames; ++var11) {
         for(int var12 = var7; var12 < this.pixelsPerFrame; var12 += var7) {
            for(int var13 = 0; var13 < var7; ++var13) {
               this.random[var11][var12 + var13] = this.random[var11][var13] + var12 * 8;
            }
         }

         try {
            Thread.sleep(50L);
         } catch (InterruptedException var16) {
         }
      }

      System.arraycopy(super.owner.banners[super.owner.currentBanner].imagePixels, 0, super.workPixels, 0, super.pixelsPerImage);

      for(int var20 = 0; var20 < super.numOfFrames; ++var20) {
         try {
            Thread.sleep(100L);
         } catch (InterruptedException var15) {
         }

         for(int var21 = 0; var21 < this.pixelsPerFrame; ++var21) {
            super.workPixels[this.random[var20][var21]] = super.owner.banners[super.owner.nextBanner].imagePixels[this.random[var20][var21]];
         }

         try {
            Thread.sleep(50L);
         } catch (InterruptedException var14) {
         }

         super.frames[var20] = super.owner.createImage(new MemoryImageSource(super.imageWidth, super.imageHeight, super.workPixels, 0, super.imageWidth));
         super.owner.prepareImage(super.frames[var20], super.owner);
      }

      super.workPixels = null;
   }
}
